<template>
  <div>
    <cv-data-table
      ref="table"
      :columns="['Component','Price']"
      row-size="short"
    >
      <template slot="data">
        <cv-data-table-row v-for="(entry, index) in sortedEntries.space" :key="index" :value="index.toString()">
          <cv-data-table-cell>{{ entry.name }}</cv-data-table-cell>
          <cv-data-table-cell>{{ formatter.format(entry.price) }}</cv-data-table-cell>
        </cv-data-table-row>
      </template>
    </cv-data-table>
  </div>
</template>

<script>
import CostBudgetEntry from '../budget/CostBudgetEntry';

export default {
  components: {

  },
  data: function() {
    return {
      formatter: new Intl.NumberFormat('en-US', {
              style: 'currency',
              currency: 'EUR',
              minimumFractionDigits: 0, // Show values as integers
              maximumFractionDigits: 0
            }),
      entries: {
        space: [
          new CostBudgetEntry("Satellite", 100000),
          new CostBudgetEntry("Transceiver", 5000),
          new CostBudgetEntry("Fantastic Transceiver", 9000)
        ]
      }
    }
  },
  computed: {
    sortedEntries() {
      var toSort = {};
      console.log(this.entries);
      Object.assign(toSort, this.entries);

      // Gather entries for each segment
      for (const key in toSort) {
        toSort[key].sort(function(a, b) {
          return b.price - a.price
        });
      }
      return toSort;
    }
  }
}
</script>

<style lang="scss">
// Carbon's tables have too long a width
.bx--data-table-container {
  min-width: 0 !important;
}
</style>
